# -*- coding: utf-8 -*-

# data source:
#Davide Anguita, Alessandro Ghio, Luca Oneto, Xavier Parra
#and Jorge L. Reyes-Ortiz.
#A Public Domain Dataset for Human Activity Recognition Using Smartphones.
#21th European Symposium on Artificial Neural Networks,
#Computational Intelligence and Machine Learning, ESANN 2013.
#Bruges, Belgium 24-26 April 2013. 

import numpy as np
from sklearn.neighbors import NearestNeighbors
from sklearn.svm import SVC
from collections import Counter

XTrain = np.loadtxt('..\\UCI HAR Dataset\\UCI HAR Dataset\\train\\X_train.txt')
yTrain = np.loadtxt('..\\UCI HAR Dataset\\UCI HAR Dataset\\train\\y_train.txt')
XTest = np.loadtxt('..\\UCI HAR Dataset\\UCI HAR Dataset\\test\\X_test.txt')
yTest = np.loadtxt('..\\UCI HAR Dataset\\UCI HAR Dataset\\test\\y_test.txt')
print(XTrain.shape)
print(yTrain.shape)
print(XTest.shape)
print(yTest.shape)

zahlAnFeatures = 200

nn = NearestNeighbors(1).fit(XTrain[:, 0:zahlAnFeatures])
distances, indices = nn.kneighbors(XTest[:, 0:zahlAnFeatures])
print(indices.shape)
total = 0
match = 0
for i in range(len(yTest)):
    total += 1
    if yTest[i] == yTrain[indices[i]]:
        match += 1;      
print(total, match)

kn = NearestNeighbors(9).fit(XTrain[:, 0:zahlAnFeatures])
distances, indices = kn.kneighbors(XTest[:, 0:zahlAnFeatures])
print(distances.shape)
total = 0
match = 0
for i in range(len(yTest)):
    total += 1
    c = Counter(yTrain[indices[i, :]])
    if yTest[i] == c.most_common(1)[0][0]:
        match += 1;        
print(total, match)

svc = SVC()
svc.fit(XTrain[:, 0:zahlAnFeatures], yTrain)
prediction = svc.predict(XTest[:, 0:zahlAnFeatures])
total = 0
match = 0
for i in range(len(yTest)):
    total += 1
    if yTest[i] == prediction[i]:
        match += 1;
print(total, match)